/*
 * M4LayerShader.fx
 * 쐬: ~[tH
 */

// C[
#define LAYER_NAME_BELOW Below
#define LAYER_NAME_ABOVE Above

#define LAYER_RT 1
#define CONTROLLER_NAME "M4LayerController.pmx"

// C[[h
// 0: ʏ
// 1: Z
// 2: Z
// 3: Z
// 4: XN[
// 5: I[o[C
// 6: n[hCg
// 7: \tgCg
// 8: rrbhCg
// 9: jACg
// 10: sCg
// 11: Ă
// 12: Ă
// 13: r ()
// 14: r ()
// 15: ̐Βl
// 16: O
// 17: F
// 18: ʓx
// 19: J[
// 20: Px
// 21: remove identical pixels
// 22: replace removed pixels by new ones

bool ControllerVisible : CONTROLOBJECT < string name = CONTROLLER_NAME; >;
float ControllerLayerTransparency : CONTROLOBJECT < string name = CONTROLLER_NAME; string item = "Transparency"; >;
float ControllerLayerMode : CONTROLOBJECT < string name = CONTROLLER_NAME; string item = "Layer mode"; >; //get the Layer mode morph value to set the layer mode
float ControllerSwitchLayers : CONTROLOBJECT < string name = CONTROLLER_NAME; string item = "Switch layers"; >; //get the Switch layers morph value to set the operation order
float ControllerClipBelow : CONTROLOBJECT < string name = CONTROLLER_NAME; string item = "Clip below"; >; //get the Clip below morph value to clip below layer input to [0;1]
float ControllerClipAbove : CONTROLOBJECT < string name = CONTROLLER_NAME; string item = "Clip above"; >; //get the Clip above morph value to clip above layer input to [0;1]

// C[x (0.0 ` 1.0)
float UILayerTransparency
<
	string UIName = "C[x";
	string UIHelp = "ʃC[ɑ΂ďʃC[̐F銄w肵܂B";
	string UIWidget = "Slider";
	float UIMin = 0;
	float UIMax = 1;
> = 0.0;

// Layer mode (0.0 ` 1.0)
float UILayerMode
<
	string UIName = "Layer Mode";
	string UIHelp = "Set the combination operation of above and below layers";
	string UIWidget = "Slider";
	float UIMin = 0;
	float UIMax = 1;
> = 0.0;

// Switch layers (0.0 ` 1.0)
float UISwitchLayers
<
	string UIName = "Switch layers";
	string UIHelp = "Switch below and above layers input in the operation";
	string UIWidget = "Slider";
	float UIMin = 0;
	float UIMax = 1;
> = 0.0;

// Clip below (0.0 ` 1.0)
float UIClipBelow
<
	string UIName = "Clip below layer";
	string UIHelp = "Clip below layer input to [0;1]";
	string UIWidget = "Slider";
	float UIMin = 0;
	float UIMax = 1;
> = 0.0;

// Clip above (0.0 ` 1.0)
float UIClipAbove
<
	string UIName = "Clip above layer";
	string UIHelp = "Clip above layer input to [0;1]";
	string UIWidget = "Slider";
	float UIMin = 0;
	float UIMax = 1;
> = 0.0;

float LayerTransparency;
float LayerMode;
float SwitchLayers;
float ClipBelow;
float ClipAbove;

////////////////////////////////////////////////////////////////

#include "..\Shared\M4ShaderCompat.fxsub"
#include "..\Shared\M4LayerCore.fxsub"

// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = float2(0.5, 0.5) / ViewportSize;

// Wϊs
float4x4 WorldViewProjMatrix : WORLDVIEWPROJECTION;
float4x4 WorldMatrix         : WORLD;
float4x4 ViewMatrix          : VIEW;
float4x4 ProjMatrix          : PROJECTION;

#if LAYER_RT

texture MERGE(LAYER_NAME_ABOVE, RT) : OFFSCREENRENDERTARGET
<
	string Description   = "Render Target for M4LayerShader.fx";
	float4 ClearColor    = { 0, 0, 0, 0 };
	float  ClearDepth    = 1.0;
	string Format = "D3DFMT_A16B16G16R16F";
	bool   AntiAlias     = true;
	int    Miplevels     = 1;
	string DefaultEffect = "* = main_default;";
>;
sampler AboveLayerSampler = sampler_state
{
	texture   = <MERGE(LAYER_NAME_ABOVE, RT)>;
	MinFilter = POINT;
	MagFilter = POINT;
	AddressU  = CLAMP;
	AddressV  = CLAMP;
};

#endif

texture MERGE(LAYER_NAME_BELOW, RT) : OFFSCREENRENDERTARGET
<
	string Description   = "Render Target for M4LayerShader.fx";
	float4 ClearColor    = { 0, 0, 0, 0 };
	float  ClearDepth    = 1.0;
	string Format = "D3DFMT_A16B16G16R16F";
	bool   AntiAlias     = true;
	int    Miplevels     = 1;
	string DefaultEffect = "* = main_default;";
>;
sampler BelowLayerSampler = sampler_state
{
	texture   = <MERGE(LAYER_NAME_BELOW, RT)>;
	MinFilter = POINT;
	MagFilter = POINT;
	AddressU  = CLAMP;
	AddressV  = CLAMP;
};

struct VS_OUTPUT
{
	float4 Pos       : POSITION;
	float4 ScreenTex : TEXCOORD0;
};

// _VF[_
VS_OUTPUT Basic_VS(MMM_SKINNING_INPUT IN)
{
	float4 Pos = Compat_GetSkinnedPosition(IN);
	VS_OUTPUT Out = (VS_OUTPUT)0;
	
	Out.Pos = mul(Pos, WorldViewProjMatrix);
	Out.ScreenTex = Out.Pos;

	return Out;
}

float4 Basic_PS(VS_OUTPUT IN) : COLOR0
{
	// RT ̍Wnɕϊ
	IN.ScreenTex.xyz /= IN.ScreenTex.w;
	float2 TransScreenTex = float2((1.0f + IN.ScreenTex.x) * 0.5f, (1.0f - IN.ScreenTex.y) * 0.5f) + ViewportOffset;

	float4 background = tex2D(BelowLayerSampler, TransScreenTex);

#if LAYER_RT
	
	LayerTransparency = ControllerLayerTransparency + UILayerTransparency;
	LayerMode = round(100*(ControllerLayerMode + UILayerMode));
	SwitchLayers = ControllerSwitchLayers + UISwitchLayers;
	ClipBelow = ControllerClipBelow + UIClipBelow;
	ClipAbove = ControllerClipAbove + UIClipAbove;
	
	float4 foreground = tex2D(AboveLayerSampler, TransScreenTex);

	background = Blend4(background, foreground, 1 - LayerTransparency);
	
#endif

	return background;
}

technique Main < string MMDPass = "object"; >
{
	pass P
	{
		AlphaTestEnable = true;
		AlphaBlendEnable = true;
		ZEnable = true;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(); 
	}
}

technique MainSS < string MMDPass = "object_ss"; >
{
	pass P
	{
		AlphaTestEnable = true;
		AlphaBlendEnable = true;
		ZEnable = true;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(); 
	}
}

technique EdgeTec < string MMDPass = "edge"; > { }
technique ShadowTec < string MMDPass = "shadow"; > { }
